<!--
  - Copyright (C) 2020-2023 The Hunter2 Contributors.
  -
  - This file is part of Hunter2.
  -
  - Hunter2 is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free
  - Software Foundation, either version 3 of the License, or (at your option) any later version.
  -
  - Hunter2 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  - PARTICULAR PURPOSE.  See the GNU Affero General Public License for more details.
  -
  - You should have received a copy of the GNU Affero General Public License along with Hunter2.  If not, see <http://www.gnu.org/licenses/>.
  -->
<template>
  <div class="admin_progress_widget">
    <div id="auto_update" class="d-flex flex-row">
      <input id="auto-update" v-model="autoUpdate" type="checkbox">
      <label for="auto-update">Update automatically</label>
    </div>

    <div id="admin-progress-filters-key" class="card">
      <div id="admin-progress-filters-header" class="card-header d-grid gap-0">
        <button
          class="btn-light collapsed"
          data-bs-toggle="collapse"
          data-bs-target="#filter-help-body"
          aria-expanded="false"
          aria-controls="filter-help-body"
        >
          Filters &amp; Help...
        </button>
      </div>
      <div id="filter-help-body" class="collapse">
        <div class="card card-body d-flex flex-row justify-content-between">
          <div id="admin-progress-filters-container" class="p-2 flex-grow-1">
            <h4>Filters</h4>
            <span class="glyphicon glyphicon-plus" />
            <p>
              <a href="?" @click.prevent="clearFilters">Reset</a>
            </p>
            <div>
              <template v-for="episode in episodes" :key="episode">
                <input
                  :id="'filter-episode-' + episode"
                  v-model="filters.episodes"
                  type="checkbox"
                  :value="episode"
                >
                <label
                  :for="'filter-episode-' + episode"
                  class="episode-label"
                >Episode {{ episode }}</label>
              </template>
            </div>
            <label for="filter-open-puzzles">
              Number of Open Puzzles
              (<input id="filter-no-hints" v-model="filters.no_hints" type="checkbox">
              <label
                for="filter-no-hints"
                class="no-margin"
              >with no scheduled/unrevealed hints</label>)
            </label>
            <el-slider
              id="filter-open-puzzles"
              v-model="filters.open_puzzles"
              range
              :max="puzzles.length || Infinity"
            />
            <label for="filter-latest-guess">Minutes since Last Guess</label>
            <el-slider
              id="filter-latest-guess"
              v-model="filters.latest_guess"
              range
              :max="oldest_latest_guess / (60 * 1000) + 1"
            />
            <label for="filter-total-guesses">Total Guesses</label>
            <el-slider
              id="filter-total-guesses"
              v-model="filters.total_guesses"
              range
              :max="max_total_guesses"
            />
          </div>
          <div id="admin-progress-key-container" class="p-4">
            <h4>Key</h4>
            <table class="card-body table">
              <thead>
                <tr>
                  <th scope="col">
                    Team has...
                  </th>
                  <th scope="col">
                    Indicated by...
                  </th>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <td>Not opened the puzzle</td>
                  <td><progress-state :state="{state: 'not_opened'}" /></td>
                </tr>
                <tr>
                  <td>Opened just now, not guessed</td>
                  <td>
                    <progress-state
                      :state="{
                        state: 'open',
                        guesses: 0,
                        time_on: 0,
                        hints_scheduled: true,
                        latest_guess: null
                      }"
                    />
                  </td>
                </tr>
                <tr>
                  <td>Open 5 mins, guessed just now</td>
                  <td>
                    <progress-state
                      :state="{
                        state: 'open',
                        guesses: 1,
                        time_on: 60 * 5,
                        hints_scheduled: true,
                        latest_guess: Date.now()
                      }"
                    />
                  </td>
                </tr>
                <tr>
                  <td>
                    Open 1h,<br>
                    latest 30 minutes ago
                  </td>
                  <td>
                    <progress-state
                      :state="{
                        state: 'open',
                        guesses: 10,
                        time_on: 60 * 60,
                        hints_scheduled: true,
                        latest_guess: now().minus({minutes: 30}).toISO()
                      }"
                    />
                  </td>
                </tr>
                <tr>
                  <td>
                    Open 3h; latest 10m ago;<br>
                    no more hints scheduled/unrevealed
                  </td>
                  <td>
                    <progress-state
                      :state="{
                        state: 'open',
                        guesses: 250,
                        time_on: 60 * 60 * 3,
                        hints_scheduled: false,
                        latest_guess: now().minus({minutes: 10}).toISO()
                      }"
                    />
                  </td>
                </tr>
                <tr>
                  <td>Solved the puzzle</td>
                  <td><progress-state :state="{state: 'solved'}" /></td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
    <table class="table admin-progress-table">
      <thead>
        <tr>
          <th scope="col">
            Team
          </th>
          <th
            v-for="field in fields"
            :key="field.label"
            scope="col"
            :title="field.headerTitle"
          >
            {{ field.label }}
          </th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(team, row) in progress_data" :key="team.id">
          <td><a :href="team.url">{{ team.name }}</a></td>
          <td v-for="(state, col) in team.progress" :key="state.puzzle_id">
            <a :href="`${team.url}#puzzle-${state.puzzle_id}`" :title="hover_info(state)">
              <progress-state :state="state" :row="row" :col="col" />
            </a>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>
<script>
import 'bootstrap/js/dist/button'
import 'bootstrap/js/dist/collapse'
import ProgressState from './progress-state.vue'
import {DateTime, Duration} from 'luxon'
import {ElSlider} from 'element-plus'

export default {
  components: {
    'el-slider': ElSlider,
    'progress-state': ProgressState,
  },
  props: {
    href: {
      required: true,
      type: String,
    },
  },
  data () {
    return {
      puzzles: [],
      team_progress: [],
      autoUpdate: true,
      filters: {
        episodes: [],
        open_puzzles: [-Infinity, Infinity],
        latest_guess: [-Infinity, Infinity],
        total_guesses: [-Infinity, Infinity],
        no_hints: false,
      },
    }
  },
  computed: {
    episodes: function () {
      return this.puzzles.map(puzzle => {
        return puzzle.episode
      }).filter((v, i, a) => a.indexOf(v) === i)
    },
    fields: function () {
      // Prepend an entry for the team name
      return this.puzzles.filter(pz => {
        // Filter out entries for puzzles from unselected episodes
        return this.displayForEpisodeNum(pz.episode)
      }).map(pz => {return {
        label: pz.short_name,
        headerTitle: pz.title,
      }})
    },
    progress_data: function () {
      return this.team_progress.map(team => {
        // Step 1: Filter out *puzzles* which are not from selected episodes
        return {name: team.name, url: team.url, progress: team.progress.filter(puzzle_progress => {
          return this.displayForEpisodeNum(puzzle_progress.episode_number)
        })}
      }).filter(team => {
        // Step 2: Apply filters to each team's row
        let open_puzzles = team.progress.filter(puzzle_progress => {
          return (
            puzzle_progress.state === 'open'
                        && (!puzzle_progress.hints_scheduled || !this.filters.no_hints)
          )
        }).length
        let latest_guess = Math.min(...team.progress.filter(
          puzzle_progress => puzzle_progress.latest_guess !== null,
        ).map(
          puzzle_progress => -DateTime.fromISO(puzzle_progress.latest_guess).diffNow().as('milliseconds'),
        ))
        let total_guesses = team.progress.map(
          puzzle_progress => puzzle_progress.guesses,
        ).filter(
          guesses => guesses !== null,
        ).reduce((a, b) => a + b, 0)
        return (
          open_puzzles >= this.filters.open_puzzles[0] &&
                    open_puzzles <= this.filters.open_puzzles[1] &&
                    latest_guess >= this.filters.latest_guess[0] * 60 * 1000 &&
                    (
          // If the user wants to filter out puzzles with no guesses that's separate
                      latest_guess === Infinity ||
                        latest_guess <= this.filters.latest_guess[1] * 60 * 1000
                    ) &&
                    total_guesses >= this.filters.total_guesses[0] &&
                    total_guesses <= this.filters.total_guesses[1]
        )
      })
    },
    oldest_latest_guess: function() {
      return this.get_oldest_latest_guess(this.puzzles.length, this.team_progress)
    },
    max_total_guesses: function () {
      return this.get_max_total_guesses(this.puzzles.length, this.team_progress)
    },
  },
  watch: {
    autoUpdate: function (on) {
      if (on) {
        this.updateData()
      }
    },
  },
  created: function() {
    this.updateData(true)
  },
  methods: {
    now: DateTime.local,
    clearFilters: function() {
      this.filters = {
        episodes: [],
        open_puzzles: [-Infinity, Infinity],
        latest_guess: [-Infinity, Infinity],
        total_guesses: [-Infinity, Infinity],
        no_hints: false,
      }
    },
    hover_info: function(state) {
      if (state.state === 'not_opened') {
        return ''
      }
      let display_format = { year: 'numeric', month: 'short', day: 'numeric', weekday: 'short', hour: 'numeric', minute: 'numeric' }
      let latest = DateTime.fromISO(state.latest_guess).toLocaleString(display_format)
      let latest_str = state.latest_guess === null ? '' : `\nlatest guess: ${latest}`
      let time_on = Duration.fromMillis(state.time_on * 1000).toFormat('hh:mm:ss')
      let time_on_str = state.time_on === null ? '' : `\ntime on: ${time_on}`
      return `guesses: ${state.guesses}` + latest_str + time_on_str
    },
    get_oldest_latest_guess: function(num_puzzles, team_progress) {
      if (num_puzzles === 0) {
        return Infinity
      }
      let oldest = Math.max(
        ...team_progress.map(team => {
          let val = Math.max(...team.progress.filter(
            puzzle_progress => puzzle_progress.latest_guess !== null,
          ).map(
            puzzle_progress => -DateTime.fromISO(puzzle_progress.latest_guess).diffNow().as('milliseconds'),
          ))
          if (val === Infinity) return 0
          return val
        }),
        0,  // If the above set was empty we want to return 0, not -Infinity
      )
      return oldest
    },
    get_max_total_guesses: function(num_puzzles, team_progress) {
      if (num_puzzles === 0) {
        return Infinity
      }
      let total = Math.max(
        ...team_progress.map(team => team.progress.map(
          puzzle_progress => puzzle_progress.guesses,
        ).filter(
          guesses => guesses !== null,
        ).reduce((a, b) => a + b, 0)),
      )
      // Math.max returns -Infinity if there are no inputs
      if (total === -Infinity) {
        return 0
      }
      return total
    },
    updateData: function(force) {
      clearTimeout(this.timer)
      if (force || this.autoUpdate) {
        let v = this
        fetch(this.href).then(
          response => response.json(),
        ).then(
          data => {
            let old_puzzle_length = v.puzzles.length
            let old_oldest_latest_guess = v.oldest_latest_guess
            let old_max_total_guesses = v.max_total_guesses
            v.puzzles = data.puzzles
            v.team_progress = data.team_progress

            if (v.filters.open_puzzles[1] === old_puzzle_length)
              v.filters.open_puzzles[1] = data.puzzles.length
            if (v.filters.latest_guess[1] === old_oldest_latest_guess)
              v.filters.latest_guess[1] = v.get_oldest_latest_guess(data.puzzles.length, data.team_progress)
            if (v.filters.total_guesses[1] === old_max_total_guesses)
              v.filters.total_guesses[1] = v.get_max_total_guesses(data.puzzles.length, data.team_progress)
          },
        )
        if (this.autoUpdate) {
          this.timer = setTimeout(this.updateData, 5000)
        }
      }
    },
    displayForEpisodeNum: function(n) {
      if (this.filters.episodes.length === 0) return true
      if (this.filters.episodes == this.episodes) return true
      return this.filters.episodes.includes(n)
    },
    log(obj) {
      console.log(obj)
    },
  },
}
</script>
<style lang="scss" scoped>
@use "sass:color";

$hover-color: #eee;

.admin-progress-table {
    position: relative;
    overflow: hidden;
    th {
        background-color: #eee;
        position: sticky;
        top: 0;
        z-index: 1;
    }
    tr:hover {
        background-color: $hover-color;
    }
    td {
        padding: 0;
        position: relative;
        vertical-align: middle;
        > a {
            display: block;
            width: 100%;
            height: 100%;
            padding: 0.25rem;
        }
    }
// Hover styling for the column with pseudo-element hackery.
    td:nth-child(n+2) {
        :hover {
            background-color: color.scale($hover-color, $lightness: -5%);
        }
        :hover::after {
            content: "";
            position: absolute;
            background-color: $hover-color;
            left: 0;
            top: -10000px;
            height: 20000px;
            width: 100%;
            z-index: -1;
        }
    }
}

#admin-progress-filters-container {
    .el-slider__runway {
        margin-top: 0;
    }
    .episode-label {
        margin-right: 0.75rem;
    }
    label.no-margin {
        margin: 0;
    }
}

#admin-progress-filters-header {
    .filters-expanded {
        float: left;
        font-weight: bold;
        font-size: 200%;
        line-height: 75%;
        vertical-align: top;
    }

    > button {
        &.collapsed::before {
            @extend .filters-expanded;
            content: "+";
        }
        &:not(.collapsed)::before {
            @extend .filters-expanded;
            content: "\2212"; /* Minus Sign */
        }
    }
}

#admin-progress-filters-key {
    width: 100%;
    > .card-header, .card-body {
        width: 100%;
    }
}
</style>
